@import '../../../../styles/mixins';
@import '../../../../styles/props';

// theme
@mixin theme($theme) {
  &:not(:disabled) {
    @include customAttribute('theme', $theme) {
      @content;
    }
  }
}

// hover
@mixin hover {
  &:hover:not(:disabled) {
    @content;
  }
}

button {
  border: 0;
  outline: 0;
  background-color: transparent;
  word-break: keep-all;
}

// common button style
.app-button {
  @include padding($button-padding);
  border-radius: $button-border-radius;
  font-size: $button-font-size;
  height: $button-height;
  cursor: pointer;

  // flat button
  &.app-flat-button {
    @include ubuntuMedium;
    line-height: 16px;
    transition: background-color $button-transition-duration;

    // disabled
    &:disabled {
      background-color: $button-disabled;
    }

    // primary theme
    @include theme('primary') {
      background-color: $button-primary;
      color: $egyptian-blue;

      // hover
      @include hover {
        background-color: $button-primary-hover;
      }
    }

    // warn theme
    @include theme('warn') {
      background-color: $button-warn;

      // hover
      @include hover {
        background-color: $button-warn-hover;
      }
    }

    // secondary theme
    @include theme('secondary') {
      background-color: $havelock-blue;
      color: $white;

      @include hover {
        background-color: lighten($havelock-blue, 10);
      }
    }
  }

  // outlined button
  &.app-outlined-button {
    transition: border $button-transition-duration, color $button-transition-duration,
      background-color $button-transition-duration;

    &:disabled {
      @include border(1px solid $button-disabled);
      color: $button-disabled;
    }

    // primary theme
    @include theme('primary') {
      @include border(1px solid $button-primary);
      color: $button-primary;

      // hover
      @include hover {
        background-color: rgba($button-primary, 0.15);
      }
    }

    // warn theme
    @include theme('warn') {
      @include border(1px solid $button-warn);
      color: $button-warn;

      // hover
      @include hover {
        background-color: rgba($button-warn, 0.15);
      }
    }

    // secondary
    @include theme('secondary') {
      @include ubuntuMedium;
      @include border(1px solid $havelock-blue);
      color: $havelock-blue;

      // hover
      @include hover {
        background-color: rgba($havelock-blue, 0.15);
      }
    }
  }

  // inline button
  &.app-inline-button {
    transition: background-color $button-transition-duration;

    // disabled
    &:disabled {
      color: $button-disabled;
    }

    // primary theme
    @include theme('primary') {
      color: $button-primary;

      // hover
      @include hover {
        background-color: rgba($button-primary, 0.15);
      }
    }

    // warn theme
    @include theme('warn') {
      color: $button-warn;

      // hover
      @include hover {
        background-color: rgba($button-warn, 0.15);
      }
    }

    // secondary theme
    @include theme('secondary') {
      color: $havelock-blue;

      // hover
      @include hover {
        background-color: rgba($havelock-blue, 0.15);
      }
    }
  }

  // icon button
  &.app-icon-button {
    @include ubuntuMedium;
    @include padding(0 13px);
    @include flex(center);
    flex-wrap: nowrap;
    white-space: nowrap;
    font-size: 12px;
    width: 100%;
    height: 24px;
    border-radius: 0;
    transition: background-color $button-transition-duration;

    // icon
    .app-icon {
      @include box(16px);
      margin-right: 6px;
    }

    // primary
    @include theme('primary') {
      color: $havelock-blue;

      // hover
      @include hover {
        background-color: rgba($havelock-blue, 0.15);
      }
    }

    // warn
    @include theme('warn') {
      color: $bittersweet;

      // hover
      @include hover {
        background-color: rgba($bittersweet, 0.15);
      }
    }
  }
}
